######################################################################  PROJECT NAME
TARGET       = GeodesicViewer
PROJECT_MAIN = gviewer_main.cpp

######################################################################  WIN DEFINES
win32:DEFINES += METRIC_EXPORTS
win32:DEFINES += MOTION_EXPORTS
win32:DEFINES += MATH_EXPORTS
win32:DEFINES += EXTRA_EXPORTS

######################################################################  RESSOURCES
RESOURCES     = gviewer.qrc

######################################################################  RELATIVE PATHS
VIEW_DIR     = $$TOP_DIR/view
MODEL_DIR    = $$TOP_DIR/model
UTILS_DIR    = $$TOP_DIR/utils

######################################################################  HEADERS and SOURCES

VIEW_HEADERS  =  $$VIEW_DIR/geodesic_view.h    $$VIEW_DIR/compass_dial.h    $$VIEW_DIR/dialwdg.h \
                 $$VIEW_DIR/locted_view.h      $$VIEW_DIR/geod_view.h \
                 $$VIEW_DIR/draw_view.h        $$VIEW_DIR/object_view.h \
                 $$VIEW_DIR/prot_view.h        $$VIEW_DIR/ledpub_widget.h \
                 $$VIEW_DIR/doc_view.h         $$VIEW_DIR/report_view.h

VIEW_SOURCES  =  $$VIEW_DIR/geodesic_view.cpp  $$VIEW_DIR/compass_dial.cpp   $$VIEW_DIR/dialwdg.cpp \
                 $$VIEW_DIR/locted_view.cpp    $$VIEW_DIR/geod_view.cpp \
                 $$VIEW_DIR/draw_view.cpp      $$VIEW_DIR/object_view.cpp \
                 $$VIEW_DIR/prot_view.cpp      $$VIEW_DIR/ledpub_widget.cpp \
                 $$VIEW_DIR/doc_view.cpp       $$VIEW_DIR/report_view.cpp

MODEL_HEADERS =  $$MODEL_DIR/opengl3d_model.h    $$MODEL_DIR/openglJacobi_model.h    $$MODEL_DIR/opengl2d_model.h
MODEL_SOURCES =  $$MODEL_DIR/opengl3d_model.cpp  $$MODEL_DIR/openglJacobi_model.cpp  $$MODEL_DIR/opengl2d_model.cpp

UTILS_HEADERS =  $$UTILS_DIR/camera.h   $$UTILS_DIR/quaternions.h \
                 $$UTILS_DIR/doubleedit_util.h   $$UTILS_DIR/greek.h \
                 $$UTILS_DIR/myobject.h  $$UTILS_DIR/utilities.h \
                 $$UTILS_DIR/gramschmidt.h

UTILS_SOURCES =  $$UTILS_DIR/camera.cpp $$UTILS_DIR/quaternions.cpp \
                 $$UTILS_DIR/doubleedit_util.cpp $$UTILS_DIR/greek.cpp \
                 $$UTILS_DIR/myobject.cpp  $$UTILS_DIR/utilities.cpp \
                 $$UTILS_DIR/gramschmidt.cpp

M4D_HEADERS   = $$M4D_DIR/extra/m4dObject.h  $$M4D_DIR/extra/m4dUtilities.h $$M4D_DIR/extra/m4dPlatform.h  \
                $$M4D_DIR/math/Mat.h $$M4D_DIR/math/VnD.h $$M4D_DIR/math/TransCoordinates.h $$M4D_DIR/math/TransfMat.h \
                $$M4D_DIR/metric/m4dMetricAlcubierre.h \
                $$M4D_DIR/metric/m4dMetricAlcubierreAccel.h \
                $$M4D_DIR/metric/m4dMetricBarriolaVilenkin.h \
                $$M4D_DIR/metric/m4dMetricBertottiKasner.h \
                $$M4D_DIR/metric/m4dMetricBesselGravWaveCart.h \
                $$M4D_DIR/metric/m4dMetricCosmicStringSchwarzschild.h \
                $$M4D_DIR/metric/m4dMetricDatabase.h \
                $$M4D_DIR/metric/m4dMetricDeSitterUniv.h \
                $$M4D_DIR/metric/m4dMetricDeSitterUnivConf.h \
                $$M4D_DIR/metric/m4dMetricEddFinkIn.h \
                $$M4D_DIR/metric/m4dMetricErnst.h \
                $$M4D_DIR/metric/m4dMetricExtremeReissnerNordstromDihole.h \
                $$M4D_DIR/metric/m4dMetricFriedmanNonEmptyNull.h \
                $$M4D_DIR/metric/m4dMetricGoedelCart.h \
                $$M4D_DIR/metric/m4dMetricGoedel.h \
                $$M4D_DIR/metric/m4dMetricGoedelScaledCart.h \
                $$M4D_DIR/metric/m4dMetricGoedelScaled.h \
                $$M4D_DIR/metric/m4dMetricHalilsoyWave.h \
                $$M4D_DIR/metric/m4dMetric.h \
                $$M4D_DIR/metric/m4dMetricJaNeWi.h \
                $$M4D_DIR/metric/m4dMetricKasner.h \
                $$M4D_DIR/metric/m4dMetricKerrBL.h \
                $$M4D_DIR/metric/m4dMetricKottler.h \
                $$M4D_DIR/metric/m4dMetricList.h \
                $$M4D_DIR/metric/m4dMetricMinkowski.h \
                $$M4D_DIR/metric/m4dMetricMinkowskiConformal.h \
                $$M4D_DIR/metric/m4dMetricMinkRotLattice.h \
                $$M4D_DIR/metric/m4dMetricMorrisThorne.h \
                $$M4D_DIR/metric/m4dMetricPainleveGullstrand.h \
                $$M4D_DIR/metric/m4dMetricPlaneGravWave.h \
                $$M4D_DIR/metric/m4dMetricPravda_C.h \
                $$M4D_DIR/metric/m4dMetricPravda_C_Can.h \
                $$M4D_DIR/metric/m4dMetricPTD_AI.h \
                $$M4D_DIR/metric/m4dMetricPTD_AII.h \
                $$M4D_DIR/metric/m4dMetricPTD_AIII.h \
                $$M4D_DIR/metric/m4dMetricPTD_BI.h \
                $$M4D_DIR/metric/m4dMetricPTD_BII.h \
                $$M4D_DIR/metric/m4dMetricPTD_BIII.h \
                $$M4D_DIR/metric/m4dMetricPTD_C.h \
                $$M4D_DIR/metric/m4dMetricReissnerNordstrom.h \
                $$M4D_DIR/metric/m4dMetricSchwarzschild.h \
                $$M4D_DIR/metric/m4dMetricSchwarzschildCart.h \
                $$M4D_DIR/metric/m4dMetricSchwarzschildIsotropic.h \
                $$M4D_DIR/metric/m4dMetricSchwarzschildTortoise.h \
                $$M4D_DIR/metric/m4dMetricStraightSpinningString.h \
                $$M4D_DIR/metric/m4dMetricSultanaDyer.h \
                $$M4D_DIR/metric/m4dMetricTaubNUT.h \
                $$M4D_DIR/metric/m4dMetricTeoWHl.h \
                $$M4D_DIR/motion/m4dFermiWalker.h \
                $$M4D_DIR/motion/m4dGeodesicGSL.h \
                $$M4D_DIR/motion/m4dGeodesic.h \
                $$M4D_DIR/motion/m4dGeodesicBS.h \
                $$M4D_DIR/motion/m4dGeodesicRK4.h \
                $$M4D_DIR/motion/m4dGeodesicDP54.h \
                $$M4D_DIR/motion/m4dGeodesicDP65.h \
                $$M4D_DIR/motion/m4dMotion.h \
                $$M4D_DIR/motion/m4dMotionDatabase.h \
                $$M4D_DIR/motion/m4dMotionList.h

M4D_SOURCES   = $$M4D_DIR/extra/m4dObject.cpp  $$M4D_DIR/extra/m4dUtilities.cpp  $$M4D_DIR/extra/m4dPlatform.cpp \
                $$M4D_DIR/math/Mat.cpp $$M4D_DIR/math/VnD.cpp $$M4D_DIR/math/TransCoordinates.cpp $$M4D_DIR/math/TransfMat.cpp \
                $$M4D_DIR/metric/m4dMetricAlcubierre.cpp \
                $$M4D_DIR/metric/m4dMetricAlcubierreAccel.cpp \
                $$M4D_DIR/metric/m4dMetricBarriolaVilenkin.cpp \
                $$M4D_DIR/metric/m4dMetricBertottiKasner.cpp \
                $$M4D_DIR/metric/m4dMetricBesselGravWaveCart.cpp \
                $$M4D_DIR/metric/m4dMetricCosmicStringSchwarzschild.cpp \
                $$M4D_DIR/metric/m4dMetricDatabase.cpp \
                $$M4D_DIR/metric/m4dMetricDeSitterUniv.cpp \
                $$M4D_DIR/metric/m4dMetricDeSitterUnivConf.cpp \
                $$M4D_DIR/metric/m4dMetricEddFinkIn.cpp \
                $$M4D_DIR/metric/m4dMetricErnst.cpp \
                $$M4D_DIR/metric/m4dMetricExtremeReissnerNordstromDihole.cpp \
                $$M4D_DIR/metric/m4dMetricFriedmanNonEmptyNull.cpp \
                $$M4D_DIR/metric/m4dMetricGoedelCart.cpp \
                $$M4D_DIR/metric/m4dMetricGoedel.cpp \
                $$M4D_DIR/metric/m4dMetricGoedelScaledCart.cpp \
                $$M4D_DIR/metric/m4dMetricGoedelScaled.cpp \
                $$M4D_DIR/metric/m4dMetricHalilsoyWave.cpp \
                $$M4D_DIR/metric/m4dMetric.cpp \
                $$M4D_DIR/metric/m4dMetricJaNeWi.cpp \
                $$M4D_DIR/metric/m4dMetricKasner.cpp \
                $$M4D_DIR/metric/m4dMetricKerrBL.cpp \
                $$M4D_DIR/metric/m4dMetricKottler.cpp \
                $$M4D_DIR/metric/m4dMetricMinkowski.cpp \
                $$M4D_DIR/metric/m4dMetricMinkowskiConformal.cpp \
                $$M4D_DIR/metric/m4dMetricMinkRotLattice.cpp \
                $$M4D_DIR/metric/m4dMetricMorrisThorne.cpp \
                $$M4D_DIR/metric/m4dMetricPainleveGullstrand.cpp \
                $$M4D_DIR/metric/m4dMetricPlaneGravWave.cpp \
                $$M4D_DIR/metric/m4dMetricPravda_C.cpp \
                $$M4D_DIR/metric/m4dMetricPravda_C_Can.cpp \
                $$M4D_DIR/metric/m4dMetricPTD_AI.cpp \
                $$M4D_DIR/metric/m4dMetricPTD_AII.cpp \
                $$M4D_DIR/metric/m4dMetricPTD_AIII.cpp \
                $$M4D_DIR/metric/m4dMetricPTD_BI.cpp \
                $$M4D_DIR/metric/m4dMetricPTD_BII.cpp \
                $$M4D_DIR/metric/m4dMetricPTD_BIII.cpp \
                $$M4D_DIR/metric/m4dMetricPTD_C.cpp \
                $$M4D_DIR/metric/m4dMetricReissnerNordstrom.cpp \
                $$M4D_DIR/metric/m4dMetricSchwarzschild.cpp \
                $$M4D_DIR/metric/m4dMetricSchwarzschildCart.cpp \
                $$M4D_DIR/metric/m4dMetricSchwarzschildIsotropic.cpp \
                $$M4D_DIR/metric/m4dMetricSchwarzschildTortoise.cpp \
                $$M4D_DIR/metric/m4dMetricStraightSpinningString.cpp \
                $$M4D_DIR/metric/m4dMetricSultanaDyer.cpp \
                $$M4D_DIR/metric/m4dMetricTaubNUT.cpp \
                $$M4D_DIR/metric/m4dMetricTeoWHl.cpp \
                $$M4D_DIR/motion/m4dFermiWalker.cpp \
                $$M4D_DIR/motion/m4dGeodesicGSL.cpp \
                $$M4D_DIR/motion/m4dGeodesic.cpp \
                $$M4D_DIR/motion/m4dGeodesicBS.cpp \
                $$M4D_DIR/motion/m4dGeodesicRK4.cpp \
                $$M4D_DIR/motion/m4dGeodesicDP54.cpp \
                $$M4D_DIR/motion/m4dGeodesicDP65.cpp \
                $$M4D_DIR/motion/m4dMotion.cpp \
                $$M4D_DIR/motion/m4dMotionDatabase.cpp


######################################################################  COMPILER
QMAKE_CC        = g++
QMAKE_CXX       = g++
QMAKE_LINK      = g++

######################################################################  INCLUDE and DEPEND
unix:!macx {
      INCLUDEPATH  +=  . .. $$VIEW_DIR  $$MODEL_DIR $$UTILS_DIR $$M4D_DIR \
                      $$GSL_DIR/include
}

win32 {
      INCLUDEPATH += .  .. "$$VIEW_DIR" "$$MODEL_DIR" "$$UTILS_DIR" "$$M4D_DIR" \
                      "$$VIEW_DIR" "$$MODEL_DIR" "$$UTILS_DIR" \
                      "$$GSL_DIR/include"
}

macx {
      INCLUDEPATH  +=  . .. $$VIEW_DIR  $$MODEL_DIR $$UTILS_DIR $$M4D_DIR \
                      $$GSL_DIR/include
}

DEPENDPATH  += 

######################################################################  intermediate moc and object files
MOC_DIR      = $$TOP_DIR/compiled/moc
OBJECTS_DIR  = $$TOP_DIR/compiled/object


######################################################################  feste Angaben
CONFIG  += console warn_on
QT      += opengl webkit script
TEMPLATE = app

######################################################################  Input
HEADERS += $$VIEW_HEADERS  $$MODEL_HEADERS  $$UTILS_HEADERS  $$M4D_HEADERS $$M4D_DIR/m4dGlobalDefs.h gdefs.h
SOURCES += $$VIEW_SOURCES  $$MODEL_SOURCES  $$UTILS_SOURCES  $$M4D_SOURCES $$PROJECT_MAIN

######################################################################  destination dir
DESTDIR  = .

unix:!macx {
    LIBS +=  -Wl,-rpath $$GSL_LIB_DIR \
             -L$$GSL_LIB_DIR -lgsl -lgslcblas \
             -L/usr/lib -lGL -lGLU
}

win32 {
    LIBS += -mwindows \
              -L"$$GSL_LIB_DIR"  $$GSL_LIB_DIR/libgsl.a  $$GSL_LIB_DIR/libgslcblas.a
}

macx {
    LIBS +=  -Wl,-rpath $$GSL_LIB_DIR \
              -L$$GSL_LIB_DIR -lgsl -lgslcblas \
#              -L/System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries -lGL -lGLU
}
